﻿var friends = null;
var cnAreaDis;
var uidS, nameS, selectFriendSendHasSB;

function refreshFriendsList() {

   friends = googleTalk.friends.toArray(); 

   //check if Google Talk is running
   if (googleTalk.talk_status==gddTalkStatusNotRunning) {
     var item = new ContentItem();
     item.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
     item.layout = gddContentItemLayoutNowrapItems;
     item.heading = "- Gtalk is -";
     item.onDetailsView = noAction;
     var item2 = new ContentItem();
     item2.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
     item2.layout = gddContentItemLayoutNowrapItems;
     item2.heading = "- not Running -";
     item2.onDetailsView = noAction;

     cnArea.removeAllContentItems();
     cnArea.addContentItem(item2, gddItemDisplayInSidebar);
     cnArea.addContentItem(item, gddItemDisplayInSidebar);
     return;
   }

   //check if Google Talk is running
   if (googleTalk.talk_status==gddTalkStatusDisconnected) {
     var item = new ContentItem();
     item.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
     item.layout = gddContentItemLayoutNowrapItems;
     item.heading = "- Google Talk is  -";
     item.onDetailsView = noAction;
     var item2 = new ContentItem();
     item2.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
     item2.layout = gddContentItemLayoutNowrapItems;
     item2.heading = "- not connected -";
     item2.onDetailsView = noAction;

     cnArea.removeAllContentItems();
     cnArea.addContentItem(item2, gddItemDisplayInSidebar);
     cnArea.addContentItem(item, gddItemDisplayInSidebar);
     return;
   }

   //check no friends
   if (friends.length==0 || friends==null) {
     var item = new ContentItem();
     item.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
     item.layout = gddContentItemLayoutNowrapItems;
     item.heading = "- No Friends Online -";
     item.onDetailsView = noAction;

     cnArea.removeAllContentItems();
     cnArea.addContentItem(item, gddItemDisplayInSidebar);
     return;
   }

      cnArea.removeAllContentItems();
      for(var t=friends.length-1; t>=0; t--) {

        var itemImg;
        var item = new ContentItem();
        item.flags = gddContentItemFlagNoRemove + gddContentItemFlagLeftIcon;
        item.layout = gddContentItemLayoutEmail;
        item.heading = friends[t].name;
        item.snippet = (friends[t].has_sidebar?"Has Sidebar":"No Sidebar")+"-"+(friends[t].status==gddFriendStatusOnline?"Online":(friends[t].status==gddFriendStatusBusy?"Busy":"Idle"));;
        item.source = friends[t].user_id;
        //item.open_command = (friends[t].has_sidebar?"Has Sidebar":"No Sidebar");
        item.tooltip = (friends[t].status==gddFriendStatusOnline?"Online":(friends[t].status==gddFriendStatusBusy?"Busy":"Idle"));
        item.onDetailsView = selectFriend;
        item.onDrawItem = DrawItem;

        cnArea.addContentItem(item, gddItemDisplayInSidebar);
      }
}

function DrawItem(item, target, graphics, x, y, width, height) {

  var frndStats = new String();
  frndStats = item.snippet;
  var splitFrndStats = frndStats.split("-");

  var bgColor2 = (splitFrndStats[0]=="Has Sidebar"?"#B27EC6":"#B0B0AF");
  graphics.DrawRect(x, y+4, x+5, height/3, bgColor2, bgColor2);

  var bgColor1 = (splitFrndStats[1]=="Online"?"#64B864":(splitFrndStats[1]=="Busy"?"#FF5655":"#EA8F5D"));
  graphics.DrawRect(x, y+20, x+5, height/3, bgColor1, bgColor1);

  graphics.DrawText(x+6, y+3, width, height, "   " + item.heading, gddColorNormalText, gddTextFlagVCenter, gddFontNormal); //gddColorNormalText gddTextFlagSingleLine +
  graphics.DrawText(x+6, y+20, width, height, "   " + item.snippet, bgColor1, gddTextFlagVCenter, gddFontNormal);
}

function selectFriend(item) {

   var frndStats = new String();
   frndStats = item.snippet;
   var splitFrndStats = frndStats.split("-");

   friendlbl.innerText = item.heading;
   selectFriendSendHasSB = (splitFrndStats[0]=="Has Sidebar"?"true":"false");

   uidS = item.source;
   nameS = item.heading;
   
   showHideFriendList();

}

function showHideFriendList() {

   if(cnAreaDis){ resetCnA(); }
   else{ setCnA(); } //alert(cnAreaDis);

   refreshFriendsList();
}

function setCnA()
{
  cnArea.height = 115;
  cnArea.width = 100;
  cnArea.x = 1;
  cnArea.y = 17;
  cnArea.visible = true;
  cnAreaDis = true
}

function resetCnA()
{
  cnArea.height = 0;
  cnArea.width = 0;
  cnArea.x = 0;
  cnArea.y = 0;
  cnArea.visible = false;
  cnAreaDis = false;
}

function noAction() {}